/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.servlet;

import org.wso2.registry.RegistryConstants;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import java.io.IOException;

public class ConsoleURLMapper {

    public static final String WEB_PATH = "web";
    public static final String PATH_ATTR = "path";

    public static final String RESOURCES_JSP = "/admin/registry-resources.jsp";
    public static final String RESOURCE_DETAILS_JSP = "/admin/resources_details.jsp";

    private String contextRoot;

    public ConsoleURLMapper(String contextRoot) {
        this.contextRoot = contextRoot;
    }

    public boolean mapAndForward(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String uri = request.getRequestURI();
        String query = request.getQueryString();

        String adminPart = uri.substring(contextRoot.length());
        if (!adminPart.startsWith(RegistryConstants.PATH_SEPARATOR + WEB_PATH)) {
            return false;
        }

        String path;
        if (uri.endsWith("") || uri.endsWith(WEB_PATH + RegistryConstants.PATH_SEPARATOR)) {
            path = RegistryConstants.ROOT_PATH;

        } else {
            path = uri.substring((contextRoot + RegistryConstants.PATH_SEPARATOR + WEB_PATH).
                    length(), uri.length());
        }

        request.getSession().setAttribute(PATH_ATTR, path);
        request.getRequestDispatcher(RESOURCES_JSP).forward(request, response);

        //if (query == null || query.length() == 0) {
        //
        //    request.getSession().setAttribute(PATH_ATTR, path);
        //    request.getRequestDispatcher(RESOURCES_JSP).forward(request, response);
        //
        //} else if (query.equals("addCollection")) {
        //
        //    request.getSession().setAttribute(PATH_ATTR, path);
        //    request.getRequestDispatcher(RESOURCE_DETAILS_JSP).forward(request, response);
        //
        //}

        return true;
    }
}
