/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.web.actions;

import org.wso2.registry.secure.SecureRegistry;
import org.wso2.registry.secure.RegistryUserManager;
import org.wso2.usermanager.Realm;

import java.util.List;
import java.util.ArrayList;

public class UserDetailsAction extends AbstractRegistryAction {

    private String userName;
    private List userRoles = new ArrayList();
    private List allRoles = new ArrayList();

    public String execute() throws Exception {

        SecureRegistry secureRegistry = (SecureRegistry) getRegistry();
        RegistryUserManager userManager = secureRegistry.getUserManager();

        Realm realm = userManager.getRealm();
        String[] rolesArray = realm.getUserStoreReader().getUserRoles(userName);
        for (int i = 0; i < rolesArray.length; i++) {
            userRoles.add(rolesArray[i]);
        }

        String[] roleNamesArray = userManager.getAllRoles();
        for (int i = 0; i < roleNamesArray.length; i++) {
            allRoles.add(roleNamesArray[i]);
        }

        return SUCCESS;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public List getUserRoles() {
        return userRoles;
    }

    public void setUserRoles(List userRoles) {
        this.userRoles = userRoles;
    }

    public List getAllRoles() {
        return allRoles;
    }

    public void setAllRoles(List allRoles) {
        this.allRoles = allRoles;
    }
}
